REM COMPILER_OPTION NODEBUG

REM definitions of system variables

GLOBAL current_0 AS BIT = 6,5
GLOBAL current_1 AS BIT = 6,6
GLOBAL led AS BIT = 6,4
GLOBAL sei AS BIT = 11,7
GLOBAL fp AS BYTE = 0x48
GLOBAL sp AS BYTE = 0x49

REM network stuff

REM the unique value is used on address-assign operations

DIM unique[4] AS BYTE = 0x1FFC

CONSTANT begin_rx_buffer AS BYTE = 0x52
GLOBAL rx_buffer_saddr AS BYTE = 0x52
GLOBAL rx_buffer_smore AS BIT = 0x52,7

GLOBAL rx_buffer_daddr AS BYTE = 0x53
GLOBAL rx_buffer_dmore AS BIT = 0x53,7

GLOBAL rx_buffer_d0 AS BYTE = 0x54
GLOBAL rx_buffer_d1 AS BYTE = 0x55
GLOBAL rx_buffer_d2 AS BYTE = 0x56
GLOBAL rx_buffer_d3 AS BYTE = 0x57
GLOBAL rx_buffer_d4 AS BYTE = 0x58
GLOBAL rx_buffer_d5 AS BYTE = 0x59

CONSTANT begin_tx_buffer AS BYTE = 0x4a
GLOBAL tx_buffer_saddr AS BYTE = 0x4a
GLOBAL tx_buffer_daddr AS BYTE = 0x4b
GLOBAL tx_buffer_d0 AS BYTE = 0x4c
GLOBAL tx_buffer_d1 AS BYTE = 0x4d
GLOBAL tx_buffer_d2 AS BYTE = 0x4e
GLOBAL tx_buffer_d3 AS BYTE = 0x4f
GLOBAL tx_buffer_d4 AS BYTE = 0x50
GLOBAL tx_buffer_d5 AS BYTE = 0x51

GLOBAL rx_packet_size AS BYTE
GLOBAL tx_packet_size AS BYTE
GLOBAL timeout AS BIT

REM useful constants

CONSTANT hi AS INTEGER = -1
CONSTANT lo AS INTEGER = 0
CONSTANT true AS INTEGER = -1
CONSTANT false AS INTEGER = 0
CONSTANT lf AS STRING = "\010"
CONSTANT cr AS STRING  = "\013"
CONSTANT line1 AS BYTE = 0x1C
CONSTANT line2 AS BYTE = 192

REM The preciding constants are for use with the LCD_COMMAND command

REM **************** SUBS ****************************

VITAL SUBROUTINE handle_error(error_code AS INTEGER)
	REM timeout handler

	IF error_code = 90
		timeout = true
	ENDIF

	LCD_DISPLAY ("TR")

	REM	print cr,lf,cr,lf,"err=", error_code

END


VITAL SUBROUTINE handle_comm(com_port AS INTEGER)

	REM fairly unsophisticated logic
	REM this subroutine gets binary input from the comm port
	REM (2 bytes or timeout)

	BINPUT rx_buffer_saddr, rx_buffer_daddr

	if rx_buffer_saddr = 99 AND rx_buffer_daddr = 99
		IDE_Download()
	endif

	REM print cr,lf,"1: ", rx_buffer_saddr,cr,lf, "2:", rx_buffer_daddr
	
	REM LCD test

	LCD_COMMAND(1)

		LCD_DISPLAY("OK ")
	IF(timeout = true)
		LCD_DISPLAY("TM")
		timeout = false
	ENDIF


	LCD_COMMAND(line2)

	IF (rx_buffer_smore = hi) 
		LCD_DISPLAY("SM ")
	ENDIF

	IF (rx_buffer_dmore = hi) 
		LCD_DISPLAY("DM")
	ENDIF

END

REM **************** MAIN ****************************

REM this unlikely looking line sets the input timeout to 10 * 10 ms
REM todo: actually poke a useful value here
REM todo: allow changing baud rate

PIPE PRINT COMM1
PIPE INPUT COMM1

print "jello world!"

ON ERROR handle_error
ON COM1 handle_comm
SET COM1 to 1

POKE (0x29, 10)

DO WHILE 1

	REM main loop

LOOP
